/**
 *
 * @author Jaime
 */
 
import java.awt.*;
import javax.swing.*;
import java.util.ArrayList;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
 
public class MyTestFrame extends JFrame implements TreeSelectionListener {

   final ArrayList<Tileset> TestTilesetArray = new ArrayList<Tileset>();
   final Tileset TestTileset = new Tileset("Bosque","./image/Tileset.png");
   final MapContainer TestMap = new MapContainer(20,15,TestTileset); //Diologue for map creator should pass already existing Tilesets
   final Project TestProject;
   
   JPanel MainProgramPanel;
   
   static int ActiveLayer;
   
   public MyTestFrame(){
      TestTilesetArray.add(TestTileset);
      TestProject = new Project("My Proj",TestTilesetArray,this);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      
      ImageIcon dummyIcon = new ImageIcon("./image/TilesetPlaceHolder.png");
      JLabel dummyLabel = new JLabel(dummyIcon);
      //dummyLabel.setSize(dummyIcon.getIconWidth(), dummyIcon.getIconHeight());
      
      MainProgramPanel = new JPanel(new BorderLayout());
      MainProgramPanel.add(new NavBar(this,TestTileset), BorderLayout.PAGE_START);
      //MainProgramPanel.add(TestTileset.getView(),BorderLayout.LINE_START);
      MainProgramPanel.add(dummyLabel,BorderLayout.LINE_START);
      MainProgramPanel.add(TestMap.getView(),BorderLayout.CENTER);
      MainProgramPanel.add(TestProject.getView(),BorderLayout.LINE_END);
      this.add(MainProgramPanel);
      //JPanel AuxPanel = new JPanel();
      //AuxPanel.add(TestTileset.getTestView());
      //this.add(AuxPanel);
      //this.add(TestTileset.getTestView());
      this.pack();
   }
   /** Required by TreeSelectionListener interface. */
   public void valueChanged(TreeSelectionEvent e) {
      JTree LocalTree = (JTree) e.getSource();
      int[] TreeRows = LocalTree.getSelectionRows();
      
      if(TreeRows.length == 0) return;
      if(TreeRows[0]==0) return;
         
      //System.out.println(e.getSource().toString());
      // Cambia los paneles para acomodar al mapa seleccionado
      BorderLayout layout = (BorderLayout)MainProgramPanel.getLayout();
      MainProgramPanel.remove(layout.getLayoutComponent(BorderLayout.CENTER));
      MainProgramPanel.remove(layout.getLayoutComponent(BorderLayout.LINE_START));
      
      MainProgramPanel.add(TestProject.getFocusedMapView(),BorderLayout.CENTER);
      MainProgramPanel.add(TestProject.getFocusedTilesetView(),BorderLayout.LINE_START);
      this.pack();
      MainProgramPanel.revalidate();
      MainProgramPanel.repaint();
   }
      
      public static void main(String args[]) {
        EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MyTestFrame().setVisible(true);
                //new MyFrame().setVisible(true);
            }
        });
    }
}



